From 7107fbf5b16f4feb6a31c277af0dac347c6d2721 Mon Sep 17 00:00:00 2001
From: Nils Philippsen <nils@redhat.com>
Date: Dec 11 2017 13:42:06 +0000
Subject: [PATCH 12/51] add --min-level option


Extend the handling of lint levels so that comparing them is possible.
Skip checks below the specified level.

---

diff --git a/src/_fedmod/cli.py b/src/_fedmod/cli.py
index b238d0a..885b2ad 100644
--- a/src/_fedmod/cli.py
+++ b/src/_fedmod/cli.py
@@ -4,8 +4,8 @@ import logging
 
 from .module_generator import ModuleGenerator
 from .module_repoquery import ModuleRepoquery
-from .modulemd_linter import ModuleMDLinter
 
+from . import modulemd_linter as mmdl
 from . import _depchase, _repodata, _fetchrepodata
 
 # fedmod uses click for argument parsing, but currently does its own
@@ -134,8 +134,14 @@ def rpms_from_srpm(pkg):
 
 # Check a modulemd YAML file for validity.
 @_cli_commands.command('lint')
+@click.option("--min-level", metavar="MINLEVEL", default='info',
+              help="The minimum level of checks to be performed ({}).".format(
+              ", ".join(mmdl.LintLevel.all_levels)))
 @click.argument("modulemd")
-def lint(modulemd):
+def lint(modulemd, min_level):
     """Validates a given modulemd YAML file"""
-    linter = ModuleMDLinter(modulemd_path=modulemd)
-    linter.lint()
+    if min_level not in mmdl.LintLevel.all_levels:
+        raise ValueError("The minimum level must be one of: {}".format(
+            ", ".join(mmdl.LintLevel.all_levels)))
+    linter = mmdl.ModuleMDLinter(modulemd_path=modulemd)
+    linter.lint(min_level=min_level)
diff --git a/src/_fedmod/modulemd_linter.py b/src/_fedmod/modulemd_linter.py
index 109ffa1..8af5630 100644
--- a/src/_fedmod/modulemd_linter.py
+++ b/src/_fedmod/modulemd_linter.py
@@ -25,28 +25,34 @@ class guidelines_link(object):
         return fn
 
 
-class LintLevelDecorator(object):
+class LintLevel(object):
     """Decorator to specify a 'severity' level for a linter method."""
 
-    all_levels = set()
+    all_levels = {}
+    max_level = -1
 
+    # We store this here because every linter method needs to be decorated with
+    # a lint level.
     lint_order = 0
 
-    def __init__(self, level):
+    def __init__(self, level_name, level):
         assert(level not in self.all_levels)
+        self.level_name = level_name
         self.level = level
-        self.all_levels.add(level)
+        self.all_levels[level_name] = level
+        LintLevel.max_level = max(LintLevel.max_level, level)
 
     def __call__(self, fn):
         fn.lint_level = self.level
-        fn.lint_order = LintLevelDecorator.lint_order
-        LintLevelDecorator.lint_order += 1
+        fn.lint_level_name = self.level_name
+        fn.lint_order = LintLevel.lint_order
+        LintLevel.lint_order += 1
         return fn
 
 
-info = LintLevelDecorator("info")
-warning = LintLevelDecorator("warning")
-error = LintLevelDecorator("error")
+info = LintLevel("info", 0)
+warning = LintLevel("warning", 1)
+error = LintLevel("error", 2)
 
 
 class detail(object):
@@ -114,20 +120,29 @@ class ModuleMDLinter(object):
         self.yaml_doc = yaml.safe_load(self.modulemd_str)
         self.yaml_data = self.yaml_doc['data']
 
-    def lint(self, levels=LintLevelDecorator.all_levels):
-        assert set(levels) <= LintLevelDecorator.all_levels
+    def lint(self, min_level=None):
+        # ensure that min_level describes a valid level
+        if min_level is None:
+            min_level = LintLevel.max_level
+        elif isinstance(min_level, int):
+            assert 0 <= min_level <= LintLevel.max_level
+        else:
+            assert min_level in LintLevel.all_levels
+            min_level = LintLevel.all_levels[min_level]
 
         lint_method_names = [x for x in dir(self) if x.startswith("lint_")]
 
+        # ensure all lint methods are properly decorated
+        assert all(
+            0 <= getattr(getattr(self, x), "lint_level", -1)
+              <= LintLevel.max_level
+            for x in lint_method_names)
+
         lint_methods = sorted(
             (y for y in (getattr(self, x) for x in lint_method_names)
-             if callable(y) and y.lint_level in levels),
+             if callable(y) and y.lint_level >= min_level),
             key=lambda x: x.lint_order)
 
-        assert all(getattr(x, "lint_level", None)
-                   in LintLevelDecorator.all_levels
-                   for x in lint_methods)
-
         flagged = []
         failed_or_skipped = set()
 
@@ -150,7 +165,7 @@ class ModuleMDLinter(object):
                     lint_detail = method.lint_detail
                 except AttributeError:
                     lint_detail = None
-                flagged.append((method.lint_level, inspect.getdoc(method),
+                flagged.append((method.lint_level_name, inspect.getdoc(method),
                                 lint_detail, method.lint_guidelines_url, e))
                 failed_or_skipped.add(method.__name__)
 

